using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace FearTheReaper {
    public class FTR_Net : ModNet {
		//public override void PlayerConnected( int index ) { }
		//public override void PlayerDisconnected(Player p) { }


		public override void NetReceive( BinBuffer bb, int sub_msg_id, MessageBuffer buffer ) {
			if( sub_msg_id != 1 ) {
RoboUtils.MsgAll( "NetReceive fail. sub_msg_id: "+sub_msg_id, RoboUtils.MsgType.Debug );return; }
RoboUtils.MsgAll( "BytesLeft(): "+bb.BytesLeft, RoboUtils.MsgType.Debug );

			int player_id = bb.ReadInt();
			if( Main.netMode != 2 ) {
RoboUtils.MsgAll( "NetReceive fail. Not server", RoboUtils.MsgType.Debug );return; }

			if( player_id == Main.myPlayer ) {
RoboUtils.MsgAll( "NetReceive fail. Not same player ("+player_id+"="+Main.myPlayer+")", RoboUtils.MsgType.Debug );return; }	// Dunno how correct this is

			Player player = Main.player[player_id];
			if( player == null || !player.active ) {
RoboUtils.MsgAll( "NetReceive fail. Bad player ("+player_id+": \""+player.name+"\")", RoboUtils.MsgType.Debug );return; }	//{ return false; }

			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			if( ftr_player == null ) {
RoboUtils.MsgAll( "NetReceive fail. Bad ftr player (\""+player.name+"\")", RoboUtils.MsgType.Debug );return; }	//{ return false; }
			
RoboUtils.MsgAll( "Loading connected player \""+player.name+"\"", RoboUtils.MsgType.Debug );
			ftr_player.Load( bb );
		}
    }
}
