using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace FearTheReaper {
    public class FTR_World : ModWorld {
		public override void Save( BinBuffer bb ) {
			if( RoboUtils.IsDebug ) {
				DebugLog.Dump( "(world netMode " + Main.netMode + ")" );
			}
		}
		//public override void Load(BinBuffer bb) { }


		public override void PostUpdate() {
			if( Main.netMode != 2 ) { return; }

			// Players must have their UpdateMe called, even on the server; this seems to work as the fallback
			for( int i = 0; i < Main.player.Length; i++ ) {
				Player player = Main.player[i];
				if( player == null || !player.active ) { continue; }

				FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
				if( ftr_player == null ) { continue; }

				ftr_player.UpdateMe(true);
			}
		}
    }
}
